# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' TradeTicks Class
#'
#' @field market 
#' @field trade_date_utc 
#' @field trade_time_utc 
#' @field timestamp 
#' @field trade_price 
#' @field trade_volume 
#' @field prev_closing_price 
#' @field change_price 
#' @field ask_bid 
#' @field sequential_id 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
TradeTicks <- R6::R6Class(
  'TradeTicks',
  public = list(
    `market` = NULL,
    `trade_date_utc` = NULL,
    `trade_time_utc` = NULL,
    `timestamp` = NULL,
    `trade_price` = NULL,
    `trade_volume` = NULL,
    `prev_closing_price` = NULL,
    `change_price` = NULL,
    `ask_bid` = NULL,
    `sequential_id` = NULL,
    initialize = function(`market`, `trade_date_utc`, `trade_time_utc`, `timestamp`, `trade_price`, `trade_volume`, `prev_closing_price`, `change_price`, `ask_bid`, `sequential_id`){
      if (!missing(`market`)) {
        stopifnot(is.character(`market`), length(`market`) == 1)
        self$`market` <- `market`
      }
      if (!missing(`trade_date_utc`)) {
        stopifnot(is.character(`trade_date_utc`), length(`trade_date_utc`) == 1)
        self$`trade_date_utc` <- `trade_date_utc`
      }
      if (!missing(`trade_time_utc`)) {
        stopifnot(is.character(`trade_time_utc`), length(`trade_time_utc`) == 1)
        self$`trade_time_utc` <- `trade_time_utc`
      }
      if (!missing(`timestamp`)) {
        self$`timestamp` <- `timestamp`
      }
      if (!missing(`trade_price`)) {
        stopifnot(is.numeric(`trade_price`), length(`trade_price`) == 1)
        self$`trade_price` <- `trade_price`
      }
      if (!missing(`trade_volume`)) {
        stopifnot(is.numeric(`trade_volume`), length(`trade_volume`) == 1)
        self$`trade_volume` <- `trade_volume`
      }
      if (!missing(`prev_closing_price`)) {
        stopifnot(is.numeric(`prev_closing_price`), length(`prev_closing_price`) == 1)
        self$`prev_closing_price` <- `prev_closing_price`
      }
      if (!missing(`change_price`)) {
        stopifnot(is.numeric(`change_price`), length(`change_price`) == 1)
        self$`change_price` <- `change_price`
      }
      if (!missing(`ask_bid`)) {
        stopifnot(is.character(`ask_bid`), length(`ask_bid`) == 1)
        self$`ask_bid` <- `ask_bid`
      }
      if (!missing(`sequential_id`)) {
        self$`sequential_id` <- `sequential_id`
      }
    },
    toJSON = function() {
      TradeTicksObject <- list()
      if (!is.null(self$`market`)) {
        TradeTicksObject[['market']] <- self$`market`
      }
      if (!is.null(self$`trade_date_utc`)) {
        TradeTicksObject[['trade_date_utc']] <- self$`trade_date_utc`
      }
      if (!is.null(self$`trade_time_utc`)) {
        TradeTicksObject[['trade_time_utc']] <- self$`trade_time_utc`
      }
      if (!is.null(self$`timestamp`)) {
        TradeTicksObject[['timestamp']] <- self$`timestamp`
      }
      if (!is.null(self$`trade_price`)) {
        TradeTicksObject[['trade_price']] <- self$`trade_price`
      }
      if (!is.null(self$`trade_volume`)) {
        TradeTicksObject[['trade_volume']] <- self$`trade_volume`
      }
      if (!is.null(self$`prev_closing_price`)) {
        TradeTicksObject[['prev_closing_price']] <- self$`prev_closing_price`
      }
      if (!is.null(self$`change_price`)) {
        TradeTicksObject[['change_price']] <- self$`change_price`
      }
      if (!is.null(self$`ask_bid`)) {
        TradeTicksObject[['ask_bid']] <- self$`ask_bid`
      }
      if (!is.null(self$`sequential_id`)) {
        TradeTicksObject[['sequential_id']] <- self$`sequential_id`
      }

      TradeTicksObject
    },
    fromJSON = function(TradeTicksJson) {
      TradeTicksObject <- jsonlite::fromJSON(TradeTicksJson)
      if (!is.null(TradeTicksObject$`market`)) {
        self$`market` <- TradeTicksObject$`market`
      }
      if (!is.null(TradeTicksObject$`trade_date_utc`)) {
        self$`trade_date_utc` <- TradeTicksObject$`trade_date_utc`
      }
      if (!is.null(TradeTicksObject$`trade_time_utc`)) {
        self$`trade_time_utc` <- TradeTicksObject$`trade_time_utc`
      }
      if (!is.null(TradeTicksObject$`timestamp`)) {
        self$`timestamp` <- TradeTicksObject$`timestamp`
      }
      if (!is.null(TradeTicksObject$`trade_price`)) {
        self$`trade_price` <- TradeTicksObject$`trade_price`
      }
      if (!is.null(TradeTicksObject$`trade_volume`)) {
        self$`trade_volume` <- TradeTicksObject$`trade_volume`
      }
      if (!is.null(TradeTicksObject$`prev_closing_price`)) {
        self$`prev_closing_price` <- TradeTicksObject$`prev_closing_price`
      }
      if (!is.null(TradeTicksObject$`change_price`)) {
        self$`change_price` <- TradeTicksObject$`change_price`
      }
      if (!is.null(TradeTicksObject$`ask_bid`)) {
        self$`ask_bid` <- TradeTicksObject$`ask_bid`
      }
      if (!is.null(TradeTicksObject$`sequential_id`)) {
        self$`sequential_id` <- TradeTicksObject$`sequential_id`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "market": %s,
           "trade_date_utc": %s,
           "trade_time_utc": %s,
           "timestamp": %s,
           "trade_price": %d,
           "trade_volume": %d,
           "prev_closing_price": %d,
           "change_price": %d,
           "ask_bid": %s,
           "sequential_id": %s
        }',
        self$`market`,
        self$`trade_date_utc`,
        self$`trade_time_utc`,
        self$`timestamp`,
        self$`trade_price`,
        self$`trade_volume`,
        self$`prev_closing_price`,
        self$`change_price`,
        self$`ask_bid`,
        self$`sequential_id`
      )
    },
    fromJSONString = function(TradeTicksJson) {
      TradeTicksObject <- jsonlite::fromJSON(TradeTicksJson)
      self$`market` <- TradeTicksObject$`market`
      self$`trade_date_utc` <- TradeTicksObject$`trade_date_utc`
      self$`trade_time_utc` <- TradeTicksObject$`trade_time_utc`
      self$`timestamp` <- TradeTicksObject$`timestamp`
      self$`trade_price` <- TradeTicksObject$`trade_price`
      self$`trade_volume` <- TradeTicksObject$`trade_volume`
      self$`prev_closing_price` <- TradeTicksObject$`prev_closing_price`
      self$`change_price` <- TradeTicksObject$`change_price`
      self$`ask_bid` <- TradeTicksObject$`ask_bid`
      self$`sequential_id` <- TradeTicksObject$`sequential_id`
    }
  )
)
